package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.TingkatResikoConverter;
import com.jasamedika.medifirst2000.dao.TingkatResikoDao;
import com.jasamedika.medifirst2000.entities.TingkatResiko;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.TingkatResikoService;
import com.jasamedika.medifirst2000.vo.TingkatResikoVO;

@Service("TingkatResikoService")
public class TingkatResikoServiceImpl extends BaseVoServiceImpl implements TingkatResikoService{

	@Autowired
	private TingkatResikoDao tingkatResikoDao;
	@Autowired
	private TingkatResikoConverter tingkatResikoConverter;
	
	@Override
	public TingkatResikoVO add(TingkatResikoVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public TingkatResikoVO update(TingkatResikoVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public TingkatResikoVO findById(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<TingkatResikoVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}

	@Override
	public Map<String, Object> findAll(Integer page, Integer take, String sort, String dir,
			Specification<TingkatResiko> spec) {
		Direction direction=null;
		
		if(dir.equalsIgnoreCase("asc")){
			direction=Sort.Direction.ASC;
		}else{
			direction=Sort.Direction.DESC;
		}
		
		Pageable pageable = new PageRequest(page, take, direction, sort);
		Page<TingkatResiko> resultPage = tingkatResikoDao.findAll(spec, pageable);
		List<TingkatResiko> resultData = resultPage.getContent();
		return constructMapReturn(resultData, resultPage.getTotalElements(), resultPage.getTotalPages());
	}

	@Override
	public Map<String, Object> save(TingkatResikoVO vo) {
		Map<String,Object> result = new HashMap<String,Object>();
		TingkatResiko model = tingkatResikoConverter.transferVOToModel(vo, new TingkatResiko());
		
		tingkatResikoDao.save(model);
		
		return result;
	}

}
